﻿using IRaCIS.Core.Application.Contracts;
using IRaCIS.Core.Domain.Share;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.Service.Reading.Dto
{

    public class GetMedicalReviewReadingTaskInDto
    {
        public Guid TrialId  { get; set; }

        public Guid TaskMedicalReviewId { get; set; }
    }


    public class GetMedicalReviewReadingTaskOutDto
    {
        //阅片类型 
        public ReadingMethod ReadingType { get; set; }


        public bool IsReadingTaskViewInOrder { get; set; }

        public List<TaskInfo> TaskList { get; set; } = new List<TaskInfo>();

        public List<TaskInfo> OtherDoctorTaskList { get; set; } = new List<TaskInfo>();


        public List<ReadingMedicineQuestion> QuestionAnswerList { get; set; } = new List<ReadingMedicineQuestion>();

    }

    public class ReadingMedicineQuestion 
    {
        /// <summary>
        /// 答案
        /// </summary>
        public string Answer { get; set; }

        public Guid MedicineQuestionId { get; set; }

        /// <summary>
        /// 类型
        /// </summary>	
		public string Type { get; set; }

        /// <summary>
        /// 父问题触发值
        /// </summary>
        public string ParentTriggerValue { get; set; } = string.Empty;

        /// <summary>
        /// 问题名称
        /// </summary>
        public string QuestionName { get; set; }

        /// <summary>
        /// 类型值
        /// </summary>
        public string TypeValue { get; set; }

        /// <summary>
        /// 是否启用
        /// </summary>
        public bool IsEnable { get; set; }

        /// <summary>
        /// 是否必须
        /// </summary>
        public bool IsRequired { get; set; }

        /// <summary>
        /// 排序
        /// </summary>
        public int ShowOrder { get; set; }

        /// <summary>
        /// 父问题
        /// </summary>
        public Guid? ParentId { get; set; }

        /// <summary>
        /// 是否确认
        /// </summary>
        public bool? IsConfirm { get; set; }


        public List<ReadingMedicineQuestion> Childrens { get; set; }
    }

    public class TaskInfo
    {
        public Guid Id { get; set; }

        /// <summary>
        /// 是否是当前任务
        /// </summary>
        public bool IsCurrentTask { get; set; } = false;

        /// <summary>
        /// 任务名称
        /// </summary>

        public string TaskName { get; set; }

        /// <summary>
        /// 盲态名称
        /// </summary>
        public string TaskBlindName { get; set; }

        public Arm ArmEnum { get; set; }

        /// <summary>
        /// 评估结果
        /// </summary>
        public string EvaluationResult { get; set; }

        public ReadingCategory ReadingCategory { get; set; }
    }

}
